
/*
 * colourdialog.c
 * Colour dialogs
 *
 * Author: 	Luke Freeman
 * Copyright 2000 - 2002 Luke Freeman.
 *
 * This file is part of whiteBOX.
 *
 * whiteBOX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * whiteBOX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */

#include "colourdialog.h"

void
on_btn_csd_clicked( GtkWidget *widget, gpointer data )
{

  gdouble colour[3];

  char end_colour[13];
  int red, green, blue;
  
  GtkColorSelection *csel;
  
  GtkWidget *wgt_main = GTK_WIDGET(GTK_WIDGET(GTK_WIDGET(GTK_WIDGET( widget )->parent)->parent)->parent);
 
  /* get the colour that was specified/selected */
  csel = (GtkColorSelection *) ((GtkColorSelectionDialog *) wgt_main)->colorsel;

  gtk_color_selection_get_color( csel, colour );

  /* get the red, green, blue values for the selected colour */
  red   = (int) (colour[0] * 65535.0) / 256;
  green = (int) (colour[1] * 65535.0) / 256;
  blue  = (int) (colour[2] * 65535.0) / 256;

  sprintf( end_colour, "#%02X%02X%02X", red, green, blue );

  cdlg_return.cdlg_rval = (int) data;

  /* if ok clicked */
  if( cdlg_return.cdlg_rval == 1 )  
  {
    strcpy( cdlg_return.cdlg_colour, end_colour );
  }
  else
    cdlg_return.cdlg_rval = (int) NULL;

  //g_print( "colour: %s\n", cdlg_return.cdlg_colour );

  gtk_main_quit();
  
  /* hide this dialog */
  gtk_widget_unrealize( wgt_main );
  gtk_widget_hide( wgt_main );
  gtk_widget_destroy( wgt_main );


}

cdlg_struct
colour_dialog( const char *title )
{

  GtkWidget *csd_itembackground;
  GtkWidget *btn_csdok;
  GtkWidget *btn_csdcancel;

  csd_itembackground = gtk_color_selection_dialog_new( title );
  gtk_widget_set_name( csd_itembackground, "csd_itembackground" );
  gtk_object_set_data( GTK_OBJECT( csd_itembackground ), 
                       "csd_itembackground", csd_itembackground );
  gtk_container_set_border_width( GTK_CONTAINER( csd_itembackground ), 10 );


  btn_csdok = GTK_COLOR_SELECTION_DIALOG( csd_itembackground )->ok_button;
  gtk_widget_set_name( btn_csdok, "btn_csdok" );
  gtk_object_set_data( GTK_OBJECT( csd_itembackground ), 
                       "btn_csdok", btn_csdok );
  gtk_widget_show( btn_csdok );
  GTK_WIDGET_SET_FLAGS( btn_csdok, GTK_CAN_DEFAULT );


  btn_csdcancel = GTK_COLOR_SELECTION_DIALOG( csd_itembackground )->cancel_button;
  gtk_widget_set_name( btn_csdcancel, "btn_csdcancel" );
  gtk_object_set_data( GTK_OBJECT( csd_itembackground ), 
                       "btn_csdcancel", btn_csdcancel );
  gtk_widget_show( btn_csdcancel );
  GTK_WIDGET_SET_FLAGS( btn_csdcancel, GTK_CAN_DEFAULT );
 

  gtk_signal_connect( GTK_OBJECT( btn_csdok ), "clicked",
                      GTK_SIGNAL_FUNC( on_btn_csd_clicked ),
                      (gpointer) 1 );

  gtk_signal_connect( GTK_OBJECT( btn_csdcancel ), "clicked",
                      GTK_SIGNAL_FUNC( on_btn_csd_clicked ),
                      (gpointer) 2 );

  gtk_widget_show( csd_itembackground );

  gtk_main();

  g_print( "clr: %d\n", cdlg_return.cdlg_rval );

  return( cdlg_return );

}
