
/*
 * interface.c
 * Glade generated main interface stuff
 *
 * Author: 	Luke Freeman
 * Copyright 2000 - 2002 Luke Freeman.
 *
 * This file is part of whiteBOX.
 *
 * whiteBOX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * whiteBOX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "wbmain.h"
#include "options.h"
#include "about.h"


GtkWidget*
create_wnd_main (void)
{
  GtkWidget *wnd_main;
  GtkWidget *vbx_main;
  GtkWidget *mbr_main;
  GtkWidget *mnu_file;
  GtkWidget *mnu_file_menu;
  GtkAccelGroup *mnu_file_menu_accels;
  GtkWidget *mnu_file_options;
  GtkWidget *separator2;
  GtkWidget *mnu_file_exit;
  GtkWidget *mnu_about;
  GtkWidget *mnu_about_menu;
  GtkAccelGroup *mnu_about_menu_accels;
  GtkWidget *mnu_about_licence;
  GtkWidget *mnu_about_website;
  GtkWidget *separator3;
  GtkWidget *mnu_about_prog;
  GtkWidget *fxd_main;
  guint btn_quit_key;
  GtkWidget *btn_quit;
  guint btn_about_key;
  GtkWidget *btn_about;
  GtkWidget *nbk_main;
  GtkWidget *lbl_bottitlemain;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  wnd_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (wnd_main, "wnd_main");
  gtk_object_set_data (GTK_OBJECT (wnd_main), "wnd_main", wnd_main);
  gtk_widget_set_usize (wnd_main, 690, 451);
  gtk_window_set_title (GTK_WINDOW (wnd_main), "whiteBOX");
  gtk_window_set_position (GTK_WINDOW (wnd_main), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (wnd_main), FALSE, FALSE, FALSE);

  vbx_main = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbx_main, "vbx_main");
  gtk_widget_ref (vbx_main);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "vbx_main", vbx_main,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbx_main);
  gtk_container_add (GTK_CONTAINER (wnd_main), vbx_main);

  mbr_main = gtk_menu_bar_new ();
  gtk_widget_set_name (mbr_main, "mbr_main");
  gtk_widget_ref (mbr_main);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mbr_main", mbr_main,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mbr_main);
  gtk_box_pack_start (GTK_BOX (vbx_main), mbr_main, FALSE, FALSE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (mbr_main), GTK_SHADOW_ETCHED_IN);

  mnu_file = gtk_menu_item_new_with_label ("File");
  gtk_widget_set_name (mnu_file, "mnu_file");
  gtk_widget_ref (mnu_file);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_file", mnu_file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnu_file);
  gtk_container_add (GTK_CONTAINER (mbr_main), mnu_file);

  mnu_file_menu = gtk_menu_new ();
  gtk_widget_set_name (mnu_file_menu, "mnu_file_menu");
  gtk_widget_ref (mnu_file_menu);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_file_menu", mnu_file_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mnu_file), mnu_file_menu);
  mnu_file_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (mnu_file_menu));

  mnu_file_options = gtk_menu_item_new_with_label ("Options");
  gtk_widget_set_name (mnu_file_options, "mnu_file_options");
  gtk_widget_ref (mnu_file_options);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_file_options", mnu_file_options,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnu_file_options);
  gtk_container_add (GTK_CONTAINER (mnu_file_menu), mnu_file_options);

  separator2 = gtk_menu_item_new ();
  gtk_widget_set_name (separator2, "separator2");
  gtk_widget_ref (separator2);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "separator2", separator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator2);
  gtk_container_add (GTK_CONTAINER (mnu_file_menu), separator2);
  gtk_widget_set_sensitive (separator2, FALSE);

  mnu_file_exit = gtk_menu_item_new_with_label ("Exit");
  gtk_widget_set_name (mnu_file_exit, "mnu_file_exit");
  gtk_widget_ref (mnu_file_exit);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_file_exit", mnu_file_exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnu_file_exit);
  gtk_container_add (GTK_CONTAINER (mnu_file_menu), mnu_file_exit);

  mnu_about = gtk_menu_item_new_with_label ("About");
  gtk_widget_set_name (mnu_about, "mnu_about");
  gtk_widget_ref (mnu_about);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_about", mnu_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnu_about);
  gtk_container_add (GTK_CONTAINER (mbr_main), mnu_about);

  mnu_about_menu = gtk_menu_new ();
  gtk_widget_set_name (mnu_about_menu, "mnu_about_menu");
  gtk_widget_ref (mnu_about_menu);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_about_menu", mnu_about_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mnu_about), mnu_about_menu);
  mnu_about_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (mnu_about_menu));

  mnu_about_licence = gtk_menu_item_new_with_label ("Licence");
  gtk_widget_set_name (mnu_about_licence, "mnu_about_licence");
  gtk_widget_ref (mnu_about_licence);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_about_licence", mnu_about_licence,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnu_about_licence);
  gtk_container_add (GTK_CONTAINER (mnu_about_menu), mnu_about_licence);

  mnu_about_website = gtk_menu_item_new_with_label ("whiteBOX website");
  gtk_widget_set_name (mnu_about_website, "mnu_about_website");
  gtk_widget_ref (mnu_about_website);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_about_website", mnu_about_website,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnu_about_website);
  gtk_container_add (GTK_CONTAINER (mnu_about_menu), mnu_about_website);

  separator3 = gtk_menu_item_new ();
  gtk_widget_set_name (separator3, "separator3");
  gtk_widget_ref (separator3);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "separator3", separator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator3);
  gtk_container_add (GTK_CONTAINER (mnu_about_menu), separator3);
  gtk_widget_set_sensitive (separator3, FALSE);

  mnu_about_prog = gtk_menu_item_new_with_label ("About whiteBOX");
  gtk_widget_set_name (mnu_about_prog, "mnu_about_prog");
  gtk_widget_ref (mnu_about_prog);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "mnu_about_prog", mnu_about_prog,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mnu_about_prog);
  gtk_container_add (GTK_CONTAINER (mnu_about_menu), mnu_about_prog);

  fxd_main = gtk_fixed_new ();
  gtk_widget_set_name (fxd_main, "fxd_main");
  gtk_widget_ref (fxd_main);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "fxd_main", fxd_main,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fxd_main);
  gtk_box_pack_start (GTK_BOX (vbx_main), fxd_main, TRUE, TRUE, 0);

  btn_quit = gtk_button_new_with_label ("");
  btn_quit_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_quit)->child),
                                   "_Quit");
  gtk_widget_add_accelerator (btn_quit, "clicked", accel_group,
                              btn_quit_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_quit, "btn_quit");
  gtk_widget_ref (btn_quit);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "btn_quit", btn_quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_quit);
  gtk_fixed_put (GTK_FIXED (fxd_main), btn_quit, 584, 392);
  gtk_widget_set_uposition (btn_quit, 584, 392);
  gtk_widget_set_usize (btn_quit, 97, 26);

  btn_about = gtk_button_new_with_label ("");
  btn_about_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_about)->child),
                                   "_About");
  gtk_widget_add_accelerator (btn_about, "clicked", accel_group,
                              btn_about_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_about, "btn_about");
  gtk_widget_ref (btn_about);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "btn_about", btn_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_about);
  gtk_fixed_put (GTK_FIXED (fxd_main), btn_about, 480, 392);
  gtk_widget_set_uposition (btn_about, 480, 392);
  gtk_widget_set_usize (btn_about, 97, 26);

  nbk_main = gtk_notebook_new ();
  gtk_widget_set_name (nbk_main, "nbk_main");
  gtk_widget_ref (nbk_main);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "nbk_main", nbk_main,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nbk_main);
  gtk_fixed_put (GTK_FIXED (fxd_main), nbk_main, 8, 8);
  gtk_widget_set_uposition (nbk_main, 8, 8);
  gtk_widget_set_usize (nbk_main, 672, 380);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (nbk_main), GTK_POS_BOTTOM);

  lbl_bottitlemain = gtk_label_new ("w h i t e B O X  -  version 0.5");
  gtk_widget_set_name (lbl_bottitlemain, "lbl_bottitlemain");
  gtk_widget_ref (lbl_bottitlemain);
  gtk_object_set_data_full (GTK_OBJECT (wnd_main), "lbl_bottitlemain", lbl_bottitlemain,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_bottitlemain);
  gtk_fixed_put (GTK_FIXED (fxd_main), lbl_bottitlemain, 8, 400);
  gtk_widget_set_uposition (lbl_bottitlemain, 8, 400);
  gtk_widget_set_usize (lbl_bottitlemain, 320, 24);
  gtk_misc_set_alignment (GTK_MISC (lbl_bottitlemain), 0.02, 0.5);

  gtk_signal_connect (GTK_OBJECT (wnd_main), "show",
                      GTK_SIGNAL_FUNC (on_wnd_main_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (wnd_main), "destroy",
                      GTK_SIGNAL_FUNC (on_wnd_main_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mnu_file_options), "activate",
                      GTK_SIGNAL_FUNC (on_mnu_file_options_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mnu_file_exit), "activate",
                      GTK_SIGNAL_FUNC (on_mnu_file_exit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mnu_about_licence), "activate",
                      GTK_SIGNAL_FUNC (on_mnu_about_licence_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mnu_about_website), "activate",
                      GTK_SIGNAL_FUNC (on_mnu_about_website_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mnu_about_prog), "activate",
                      GTK_SIGNAL_FUNC (on_mnu_about_prog_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_quit), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_quit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_about), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_about_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (wnd_main), accel_group);

  return wnd_main;
}

GtkWidget*
create_dlg_about (void)
{
  GtkWidget *dlg_about;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *pixmap1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  guint btn_abtok_key;
  GtkWidget *btn_abtok;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  dlg_about = gtk_dialog_new ();
  gtk_widget_set_name (dlg_about, "dlg_about");
  gtk_object_set_data (GTK_OBJECT (dlg_about), "dlg_about", dlg_about);
  gtk_widget_set_usize (dlg_about, 435, 337);
  gtk_window_set_title (GTK_WINDOW (dlg_about), "About whiteBOX");
  gtk_window_set_position (GTK_WINDOW (dlg_about), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dlg_about), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dlg_about), FALSE, FALSE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dlg_about)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (dlg_about), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (dlg_about), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  pixmap1 = create_pixmap (dlg_about, "title1e.xpm");
  gtk_widget_set_name (pixmap1, "pixmap1");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (dlg_about), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (vbox1), pixmap1, FALSE, FALSE, 0);
  gtk_widget_set_usize (pixmap1, -2, 171);
  gtk_misc_set_alignment (GTK_MISC (pixmap1), 0.35, 7.45058e-09);
  gtk_misc_set_padding (GTK_MISC (pixmap1), 0, 8);

  label1 = gtk_label_new ("whiteBOX - Blackbox configuration tool.\nCopyright (C) 2000-2002, Luke Freeman.\n\nVersion:       0.5.\nRevision:  Sat Dec  7 09:22:47 2002 \nLicence:    GPL.");
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dlg_about), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, FALSE, TRUE, 10);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label1), 0.18, 0.42);

  dialog_action_area1 = GTK_DIALOG (dlg_about)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (dlg_about), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  btn_abtok = gtk_button_new_with_label ("");
  btn_abtok_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_abtok)->child),
                                   "_OK");
  gtk_widget_add_accelerator (btn_abtok, "clicked", accel_group,
                              btn_abtok_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_abtok, "btn_abtok");
  gtk_widget_ref (btn_abtok);
  gtk_object_set_data_full (GTK_OBJECT (dlg_about), "btn_abtok", btn_abtok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_abtok);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), btn_abtok, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_abtok, 280, 26);

  gtk_signal_connect (GTK_OBJECT (btn_abtok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_abtok_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (dlg_about), accel_group);

  return dlg_about;
}

GtkWidget*
create_dlg_info (void)
{
  GtkWidget *dlg_info;
  GtkWidget *dialog_vbox2;
  GtkWidget *scrolledwindow1;
  GtkWidget *txt_infocontent;
  GtkWidget *dialog_action_area2;
  guint btn_infook_key;
  GtkWidget *btn_infook;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  dlg_info = gtk_dialog_new ();
  gtk_widget_set_name (dlg_info, "dlg_info");
  gtk_object_set_data (GTK_OBJECT (dlg_info), "dlg_info", dlg_info);
  gtk_widget_set_usize (dlg_info, 359, 260);
  gtk_window_set_title (GTK_WINDOW (dlg_info), "info: [none]");
  gtk_window_set_default_size (GTK_WINDOW (dlg_info), 385, 295);

  dialog_vbox2 = GTK_DIALOG (dlg_info)->vbox;
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_object_set_data (GTK_OBJECT (dlg_info), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (dlg_info), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  txt_infocontent = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (txt_infocontent, "txt_infocontent");
  gtk_widget_ref (txt_infocontent);
  gtk_object_set_data_full (GTK_OBJECT (dlg_info), "txt_infocontent", txt_infocontent,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txt_infocontent);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), txt_infocontent);

  dialog_action_area2 = GTK_DIALOG (dlg_info)->action_area;
  gtk_widget_set_name (dialog_action_area2, "dialog_action_area2");
  gtk_object_set_data (GTK_OBJECT (dlg_info), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  btn_infook = gtk_button_new_with_label ("");
  btn_infook_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_infook)->child),
                                   "_OK");
  gtk_widget_add_accelerator (btn_infook, "clicked", accel_group,
                              btn_infook_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_infook, "btn_infook");
  gtk_widget_ref (btn_infook);
  gtk_object_set_data_full (GTK_OBJECT (dlg_info), "btn_infook", btn_infook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_infook);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), btn_infook, FALSE, TRUE, 0);
  gtk_widget_set_usize (btn_infook, -2, 26);

  gtk_signal_connect (GTK_OBJECT (btn_infook), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_infook_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (dlg_info), accel_group);

  return dlg_info;
}

GtkWidget*
create_wnd_options (void)
{
  GtkWidget *wnd_options;
  GtkWidget *fxd_options;
  guint btn_optsave_key;
  GtkWidget *btn_optsave;
  GtkWidget *nbk_options;
  GtkWidget *fxd_pluginpage;
  GtkWidget *lst_optplugins;
  GtkWidget *lbl_lstoptplugname;
  GtkWidget *lbl_lstoptplugloc;
  GtkWidget *btn_optplugadd;
  GtkWidget *btn_optplugremove;
  GtkWidget *btn_optplugedit;
  GtkWidget *btn_optplugrefresh;
  GtkWidget *tbr_optplug;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *btn_tbrplugup;
  GtkWidget *btn_tbrplugdown;
  GtkWidget *btn_tbrpluginfo;
  GtkWidget *label2;
  GtkWidget *lbl_optpluginpage;
  guint btn_optok_key;
  GtkWidget *btn_optok;
  guint btn_optcancel_key;
  GtkWidget *btn_optcancel;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  wnd_options = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (wnd_options, "wnd_options");
  gtk_object_set_data (GTK_OBJECT (wnd_options), "wnd_options", wnd_options);
  gtk_widget_set_usize (wnd_options, 402, 267);
  gtk_window_set_title (GTK_WINDOW (wnd_options), "whiteBOX: options");
  gtk_window_set_modal (GTK_WINDOW (wnd_options), TRUE);
  gtk_window_set_policy (GTK_WINDOW (wnd_options), FALSE, FALSE, FALSE);

  fxd_options = gtk_fixed_new ();
  gtk_widget_set_name (fxd_options, "fxd_options");
  gtk_widget_ref (fxd_options);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "fxd_options", fxd_options,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fxd_options);
  gtk_container_add (GTK_CONTAINER (wnd_options), fxd_options);

  btn_optsave = gtk_button_new_with_label ("");
  btn_optsave_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_optsave)->child),
                                   "_Apply");
  gtk_widget_add_accelerator (btn_optsave, "clicked", accel_group,
                              btn_optsave_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_optsave, "btn_optsave");
  gtk_widget_ref (btn_optsave);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_optsave", btn_optsave,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_optsave);
  gtk_fixed_put (GTK_FIXED (fxd_options), btn_optsave, 88, 232);
  gtk_widget_set_uposition (btn_optsave, 88, 232);
  gtk_widget_set_usize (btn_optsave, 97, 26);

  nbk_options = gtk_notebook_new ();
  gtk_widget_set_name (nbk_options, "nbk_options");
  gtk_widget_ref (nbk_options);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "nbk_options", nbk_options,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nbk_options);
  gtk_fixed_put (GTK_FIXED (fxd_options), nbk_options, 8, 8);
  gtk_widget_set_uposition (nbk_options, 8, 8);
  gtk_widget_set_usize (nbk_options, 384, 212);

  fxd_pluginpage = gtk_fixed_new ();
  gtk_widget_set_name (fxd_pluginpage, "fxd_pluginpage");
  gtk_widget_ref (fxd_pluginpage);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "fxd_pluginpage", fxd_pluginpage,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fxd_pluginpage);
  gtk_container_add (GTK_CONTAINER (nbk_options), fxd_pluginpage);

  lst_optplugins = gtk_clist_new (2);
  gtk_widget_set_name (lst_optplugins, "lst_optplugins");
  gtk_widget_ref (lst_optplugins);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "lst_optplugins", lst_optplugins,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lst_optplugins);
  gtk_fixed_put (GTK_FIXED (fxd_pluginpage), lst_optplugins, 8, 8);
  gtk_widget_set_uposition (lst_optplugins, 8, 8);
  gtk_widget_set_usize (lst_optplugins, 360, 120);
  gtk_clist_set_column_width (GTK_CLIST (lst_optplugins), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (lst_optplugins), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (lst_optplugins));

  lbl_lstoptplugname = gtk_label_new ("Name");
  gtk_widget_set_name (lbl_lstoptplugname, "lbl_lstoptplugname");
  gtk_widget_ref (lbl_lstoptplugname);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "lbl_lstoptplugname", lbl_lstoptplugname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_lstoptplugname);
  gtk_clist_set_column_widget (GTK_CLIST (lst_optplugins), 0, lbl_lstoptplugname);

  lbl_lstoptplugloc = gtk_label_new ("Location");
  gtk_widget_set_name (lbl_lstoptplugloc, "lbl_lstoptplugloc");
  gtk_widget_ref (lbl_lstoptplugloc);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "lbl_lstoptplugloc", lbl_lstoptplugloc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_lstoptplugloc);
  gtk_clist_set_column_widget (GTK_CLIST (lst_optplugins), 1, lbl_lstoptplugloc);

  btn_optplugadd = gtk_button_new_with_label ("Add");
  gtk_widget_set_name (btn_optplugadd, "btn_optplugadd");
  gtk_widget_ref (btn_optplugadd);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_optplugadd", btn_optplugadd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_optplugadd);
  gtk_fixed_put (GTK_FIXED (fxd_pluginpage), btn_optplugadd, 8, 152);
  gtk_widget_set_uposition (btn_optplugadd, 8, 152);
  gtk_widget_set_usize (btn_optplugadd, 56, 24);

  btn_optplugremove = gtk_button_new_with_label ("Remove");
  gtk_widget_set_name (btn_optplugremove, "btn_optplugremove");
  gtk_widget_ref (btn_optplugremove);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_optplugremove", btn_optplugremove,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_optplugremove);
  gtk_fixed_put (GTK_FIXED (fxd_pluginpage), btn_optplugremove, 136, 152);
  gtk_widget_set_uposition (btn_optplugremove, 136, 152);
  gtk_widget_set_usize (btn_optplugremove, 56, 24);

  btn_optplugedit = gtk_button_new_with_label ("Edit");
  gtk_widget_set_name (btn_optplugedit, "btn_optplugedit");
  gtk_widget_ref (btn_optplugedit);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_optplugedit", btn_optplugedit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_optplugedit);
  gtk_fixed_put (GTK_FIXED (fxd_pluginpage), btn_optplugedit, 72, 152);
  gtk_widget_set_uposition (btn_optplugedit, 72, 152);
  gtk_widget_set_usize (btn_optplugedit, 56, 24);

  btn_optplugrefresh = gtk_button_new_with_label ("Refresh");
  gtk_widget_set_name (btn_optplugrefresh, "btn_optplugrefresh");
  gtk_widget_ref (btn_optplugrefresh);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_optplugrefresh", btn_optplugrefresh,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_optplugrefresh);
  gtk_fixed_put (GTK_FIXED (fxd_pluginpage), btn_optplugrefresh, 200, 152);
  gtk_widget_set_uposition (btn_optplugrefresh, 200, 152);
  gtk_widget_set_usize (btn_optplugrefresh, 56, 24);

  tbr_optplug = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_widget_set_name (tbr_optplug, "tbr_optplug");
  gtk_widget_ref (tbr_optplug);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "tbr_optplug", tbr_optplug,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tbr_optplug);
  gtk_fixed_put (GTK_FIXED (fxd_pluginpage), tbr_optplug, 285, 152);
  gtk_widget_set_uposition (tbr_optplug, 285, 152);
  gtk_widget_set_usize (tbr_optplug, 88, 25);

  tmp_toolbar_icon = create_pixmap (wnd_options, "arrowup.xpm");
  btn_tbrplugup = gtk_toolbar_append_element (GTK_TOOLBAR (tbr_optplug),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (btn_tbrplugup, "btn_tbrplugup");
  gtk_widget_ref (btn_tbrplugup);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_tbrplugup", btn_tbrplugup,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_tbrplugup);
  gtk_widget_set_usize (btn_tbrplugup, 24, 24);

  gtk_toolbar_append_space (GTK_TOOLBAR (tbr_optplug));

  tmp_toolbar_icon = create_pixmap (wnd_options, "arrowdn.xpm");
  btn_tbrplugdown = gtk_toolbar_append_element (GTK_TOOLBAR (tbr_optplug),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "button3",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (btn_tbrplugdown, "btn_tbrplugdown");
  gtk_widget_ref (btn_tbrplugdown);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_tbrplugdown", btn_tbrplugdown,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_tbrplugdown);

  gtk_toolbar_append_space (GTK_TOOLBAR (tbr_optplug));

  tmp_toolbar_icon = create_pixmap (wnd_options, "doc1.xpm");
  btn_tbrpluginfo = gtk_toolbar_append_element (GTK_TOOLBAR (tbr_optplug),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "button4",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (btn_tbrpluginfo, "btn_tbrpluginfo");
  gtk_widget_ref (btn_tbrpluginfo);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_tbrpluginfo", btn_tbrpluginfo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_tbrpluginfo);

  label2 = gtk_label_new ("NOTE: You need to press 'refresh' for the settings to take effect.");
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_fixed_put (GTK_FIXED (fxd_pluginpage), label2, 8, 130);
  gtk_widget_set_uposition (label2, 8, 130);
  gtk_widget_set_usize (label2, 360, 16);

  lbl_optpluginpage = gtk_label_new ("Plugins");
  gtk_widget_set_name (lbl_optpluginpage, "lbl_optpluginpage");
  gtk_widget_ref (lbl_optpluginpage);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "lbl_optpluginpage", lbl_optpluginpage,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_optpluginpage);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (nbk_options), gtk_notebook_get_nth_page (GTK_NOTEBOOK (nbk_options), 0), lbl_optpluginpage);

  btn_optok = gtk_button_new_with_label ("");
  btn_optok_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_optok)->child),
                                   "_Ok");
  gtk_widget_add_accelerator (btn_optok, "clicked", accel_group,
                              btn_optok_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_optok, "btn_optok");
  gtk_widget_ref (btn_optok);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_optok", btn_optok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_optok);
  gtk_fixed_put (GTK_FIXED (fxd_options), btn_optok, 192, 232);
  gtk_widget_set_uposition (btn_optok, 192, 232);
  gtk_widget_set_usize (btn_optok, 97, 26);

  btn_optcancel = gtk_button_new_with_label ("");
  btn_optcancel_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_optcancel)->child),
                                   "_Cancel");
  gtk_widget_add_accelerator (btn_optcancel, "clicked", accel_group,
                              btn_optcancel_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_optcancel, "btn_optcancel");
  gtk_widget_ref (btn_optcancel);
  gtk_object_set_data_full (GTK_OBJECT (wnd_options), "btn_optcancel", btn_optcancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_optcancel);
  gtk_fixed_put (GTK_FIXED (fxd_options), btn_optcancel, 296, 232);
  gtk_widget_set_uposition (btn_optcancel, 296, 232);
  gtk_widget_set_usize (btn_optcancel, 97, 26);

  gtk_signal_connect (GTK_OBJECT (wnd_options), "show",
                      GTK_SIGNAL_FUNC (on_wnd_options_show),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_optsave), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_optsave_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_optplugadd), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_optplugadd_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_optplugremove), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_optplugremove_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_optplugedit), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_optplugedit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_optplugrefresh), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_optplugrefresh_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_tbrplugup), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_tbrplugup_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_tbrplugdown), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_tbrplugdown_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_tbrpluginfo), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_tbrpluginfo_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_optok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_optok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_optcancel), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_optcancel_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (wnd_options), accel_group);

  return wnd_options;
}

GtkWidget*
create_dlg_addplugin (void)
{
  GtkWidget *dlg_addplugin;
  GtkWidget *vbx_addplugin;
  GtkWidget *tbl_addplugin;
  GtkWidget *lbl_plugname;
  GtkWidget *lbl_plugloc;
  GtkWidget *txt_plugname;
  GtkWidget *hbx_plugloc;
  GtkWidget *txt_plugloc;
  GtkWidget *btn_browseplug;
  GtkWidget *ckk_plugactive;
  GtkWidget *daa_addplugin;
  GtkWidget *hbx_plugbtns;
  guint btn_cancelplug_key;
  GtkWidget *btn_cancelplug;
  guint btn_addplug_key;
  GtkWidget *btn_addplug;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  dlg_addplugin = gtk_dialog_new ();
  gtk_widget_set_name (dlg_addplugin, "dlg_addplugin");
  gtk_object_set_data (GTK_OBJECT (dlg_addplugin), "dlg_addplugin", dlg_addplugin);
  gtk_window_set_title (GTK_WINDOW (dlg_addplugin), "Add Plugin");
  gtk_window_set_position (GTK_WINDOW (dlg_addplugin), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (dlg_addplugin), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dlg_addplugin), FALSE, FALSE, FALSE);

  vbx_addplugin = GTK_DIALOG (dlg_addplugin)->vbox;
  gtk_widget_set_name (vbx_addplugin, "vbx_addplugin");
  gtk_object_set_data (GTK_OBJECT (dlg_addplugin), "vbx_addplugin", vbx_addplugin);
  gtk_widget_show (vbx_addplugin);

  tbl_addplugin = gtk_table_new (3, 2, FALSE);
  gtk_widget_set_name (tbl_addplugin, "tbl_addplugin");
  gtk_widget_ref (tbl_addplugin);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "tbl_addplugin", tbl_addplugin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tbl_addplugin);
  gtk_box_pack_start (GTK_BOX (vbx_addplugin), tbl_addplugin, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (tbl_addplugin), 8);
  gtk_table_set_row_spacings (GTK_TABLE (tbl_addplugin), 5);
  gtk_table_set_col_spacings (GTK_TABLE (tbl_addplugin), 8);

  lbl_plugname = gtk_label_new ("Plugin Name:");
  gtk_widget_set_name (lbl_plugname, "lbl_plugname");
  gtk_widget_ref (lbl_plugname);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "lbl_plugname", lbl_plugname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_plugname);
  gtk_table_attach (GTK_TABLE (tbl_addplugin), lbl_plugname, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (lbl_plugname), 0, 0.5);

  lbl_plugloc = gtk_label_new ("Plugin Location:");
  gtk_widget_set_name (lbl_plugloc, "lbl_plugloc");
  gtk_widget_ref (lbl_plugloc);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "lbl_plugloc", lbl_plugloc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_plugloc);
  gtk_table_attach (GTK_TABLE (tbl_addplugin), lbl_plugloc, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (lbl_plugloc), 0, 0.5);

  txt_plugname = gtk_entry_new ();
  gtk_widget_set_name (txt_plugname, "txt_plugname");
  gtk_widget_ref (txt_plugname);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "txt_plugname", txt_plugname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txt_plugname);
  gtk_table_attach (GTK_TABLE (tbl_addplugin), txt_plugname, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  hbx_plugloc = gtk_hbox_new (FALSE, 6);
  gtk_widget_set_name (hbx_plugloc, "hbx_plugloc");
  gtk_widget_ref (hbx_plugloc);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "hbx_plugloc", hbx_plugloc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbx_plugloc);
  gtk_table_attach (GTK_TABLE (tbl_addplugin), hbx_plugloc, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  txt_plugloc = gtk_entry_new ();
  gtk_widget_set_name (txt_plugloc, "txt_plugloc");
  gtk_widget_ref (txt_plugloc);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "txt_plugloc", txt_plugloc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txt_plugloc);
  gtk_box_pack_start (GTK_BOX (hbx_plugloc), txt_plugloc, TRUE, TRUE, 0);

  btn_browseplug = gtk_button_new_with_label ("..");
  gtk_widget_set_name (btn_browseplug, "btn_browseplug");
  gtk_widget_ref (btn_browseplug);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "btn_browseplug", btn_browseplug,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_browseplug);
  gtk_box_pack_start (GTK_BOX (hbx_plugloc), btn_browseplug, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_browseplug, 21, 21);

  ckk_plugactive = gtk_check_button_new_with_label ("Make this plugin active");
  gtk_widget_set_name (ckk_plugactive, "ckk_plugactive");
  gtk_widget_ref (ckk_plugactive);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "ckk_plugactive", ckk_plugactive,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_table_attach (GTK_TABLE (tbl_addplugin), ckk_plugactive, 0, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  daa_addplugin = GTK_DIALOG (dlg_addplugin)->action_area;
  gtk_widget_set_name (daa_addplugin, "daa_addplugin");
  gtk_object_set_data (GTK_OBJECT (dlg_addplugin), "daa_addplugin", daa_addplugin);
  gtk_widget_show (daa_addplugin);
  gtk_container_set_border_width (GTK_CONTAINER (daa_addplugin), 10);

  hbx_plugbtns = gtk_hbox_new (FALSE, 6);
  gtk_widget_set_name (hbx_plugbtns, "hbx_plugbtns");
  gtk_widget_ref (hbx_plugbtns);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "hbx_plugbtns", hbx_plugbtns,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbx_plugbtns);
  gtk_box_pack_start (GTK_BOX (daa_addplugin), hbx_plugbtns, FALSE, TRUE, 0);
  gtk_widget_set_usize (hbx_plugbtns, -2, 22);

  btn_cancelplug = gtk_button_new_with_label ("");
  btn_cancelplug_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_cancelplug)->child),
                                   "_Cancel");
  gtk_widget_add_accelerator (btn_cancelplug, "clicked", accel_group,
                              btn_cancelplug_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_cancelplug, "btn_cancelplug");
  gtk_widget_ref (btn_cancelplug);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "btn_cancelplug", btn_cancelplug,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_cancelplug);
  gtk_box_pack_end (GTK_BOX (hbx_plugbtns), btn_cancelplug, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_cancelplug, 60, -2);

  btn_addplug = gtk_button_new_with_label ("");
  btn_addplug_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_addplug)->child),
                                   "_OK");
  gtk_widget_add_accelerator (btn_addplug, "clicked", accel_group,
                              btn_addplug_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_set_name (btn_addplug, "btn_addplug");
  gtk_widget_ref (btn_addplug);
  gtk_object_set_data_full (GTK_OBJECT (dlg_addplugin), "btn_addplug", btn_addplug,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_addplug);
  gtk_box_pack_end (GTK_BOX (hbx_plugbtns), btn_addplug, FALSE, FALSE, 0);
  gtk_widget_set_usize (btn_addplug, 60, -2);

  gtk_signal_connect (GTK_OBJECT (btn_browseplug), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_browseplug_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_cancelplug), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_cancelplug_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_addplug), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_addplug_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (dlg_addplugin), accel_group);

  return dlg_addplugin;
}

