
/*
 * bgset.h
 * BG tool callbacks header
 *
 * Author: 	Luke Freeman
 * Copyright 2000 - 2002 Luke Freeman.
 *
 * This file is part of whiteBOX.
 *
 * whiteBOX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * whiteBOX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */

#define BGSET_DEBUG 0

typedef struct
{
  gchar *img_key;
  gchar *img_loc;
  gchar *img_bg;
  gchar *img_x;
  gchar *img_y;
  gchar *img_z;
  gchar *img_scale;
  gchar *img_opacity;
} bg_image;

bg_image *
new_bg_image( gchar *key, gchar *loc, gchar *bg, 
          gchar *xpos, gchar *ypos, gchar *zpos, gchar *scale,
          gchar *opacity );

GtkWidget* create_wnd_additem (void);
GtkWidget* create_wnd_about (void);
GtkWidget* create_wnd_options (void);
GtkWidget* create_dialog1 (void);

char *
get_long_mode ( char *posz );

void
on_btn_setbg_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_quit_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_bgnormbrowse_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_bgnormcol_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_txt_cbobgnormpos_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_txt_bgnormloc_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_btn_addpic_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_editpic_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_delpic_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_delall_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrsavedup_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrsaveddown_clicked            (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_wnd_additem_destroy_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_wnd_additem_show                    (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_txt_imageloc_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_btn_set_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_cancel_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_imagebrowse_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_bgcolour_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_txt_cboimagepos_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_btn_aboutclose_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_optcancel_clicked               (GtkButton       *button,
                                        gpointer         user_data);
