/*
 * convertwin.c
 * Conversion window interface definitions -- not implemented
 *
 * Author: 	Luke Freeman
 * Copyright 2000 - 2002 Luke Freeman.
 *
 * This file is part of whiteBOX.
 *
 * whiteBOX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * whiteBOX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */


#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "convertwin.h"
#include "convertfilecb.h"

#include "../../support.h"

GtkWidget*
create_wnd_keyconvert (void)
{
  GtkWidget *wnd_keyconvert;
  GtkWidget *fxd_keycvtmain;
  GtkWidget *txt_keycvtfile;
  GtkWidget *lbl_keycvtfilehed;
  GtkWidget *lbl_keycvtfiletohed;
  GtkWidget *btn_keycvtlookupfile;
  GtkWidget *prg_keycvtprogress;
  guint btn_keycvtconvert_key;
  GtkWidget *btn_keycvtconvert;
  guint btn_keycvtcancel_key;
  GtkWidget *btn_keycvtcancel;
  GtkWidget *cbo_keycvttypeto;
  GList *cbo_keycvttypeto_items = NULL;
  GtkWidget *txt_cbokeycvttypeto;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  wnd_keyconvert = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (wnd_keyconvert), "wnd_keyconvert", wnd_keyconvert);
  gtk_widget_set_usize (wnd_keyconvert, 288, 127);
  gtk_window_set_title (GTK_WINDOW (wnd_keyconvert), _("Convert A Key File"));
  gtk_window_set_policy (GTK_WINDOW (wnd_keyconvert), FALSE, FALSE, FALSE);

  fxd_keycvtmain = gtk_fixed_new ();
  gtk_widget_ref (fxd_keycvtmain);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "fxd_keycvtmain", fxd_keycvtmain,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fxd_keycvtmain);
  gtk_container_add (GTK_CONTAINER (wnd_keyconvert), fxd_keycvtmain);

  txt_keycvtfile = gtk_entry_new ();
  gtk_widget_ref (txt_keycvtfile);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "txt_keycvtfile", txt_keycvtfile,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txt_keycvtfile);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), txt_keycvtfile, 80, 8);
  gtk_widget_set_uposition (txt_keycvtfile, 80, 8);
  gtk_widget_set_usize (txt_keycvtfile, 176, 19);

  lbl_keycvtfilehed = gtk_label_new (_("File:"));
  gtk_widget_ref (lbl_keycvtfilehed);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "lbl_keycvtfilehed", lbl_keycvtfilehed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_keycvtfilehed);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), lbl_keycvtfilehed, 8, 10);
  gtk_widget_set_uposition (lbl_keycvtfilehed, 8, 10);
  gtk_widget_set_usize (lbl_keycvtfilehed, 32, 16);
  gtk_misc_set_alignment (GTK_MISC (lbl_keycvtfilehed), 7.45058e-09, 0.5);

  lbl_keycvtfiletohed = gtk_label_new (_("Convert To:"));
  gtk_widget_ref (lbl_keycvtfiletohed);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "lbl_keycvtfiletohed", lbl_keycvtfiletohed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lbl_keycvtfiletohed);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), lbl_keycvtfiletohed, 8, 32);
  gtk_widget_set_uposition (lbl_keycvtfiletohed, 8, 32);
  gtk_widget_set_usize (lbl_keycvtfiletohed, 72, 16);
  gtk_misc_set_alignment (GTK_MISC (lbl_keycvtfiletohed), 7.45058e-09, 0.5);

  btn_keycvtlookupfile = gtk_button_new_with_label (_(".."));
  gtk_widget_ref (btn_keycvtlookupfile);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "btn_keycvtlookupfile", btn_keycvtlookupfile,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_keycvtlookupfile);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), btn_keycvtlookupfile, 261, 8);
  gtk_widget_set_uposition (btn_keycvtlookupfile, 261, 8);
  gtk_widget_set_usize (btn_keycvtlookupfile, 19, 19);

  prg_keycvtprogress = gtk_progress_bar_new ();
  gtk_widget_ref (prg_keycvtprogress);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "prg_keycvtprogress", prg_keycvtprogress,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (prg_keycvtprogress);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), prg_keycvtprogress, 8, 64);
  gtk_widget_set_uposition (prg_keycvtprogress, 8, 64);
  gtk_widget_set_usize (prg_keycvtprogress, 272, 19);
  gtk_progress_set_show_text (GTK_PROGRESS (prg_keycvtprogress), TRUE);
  gtk_progress_set_text_alignment (GTK_PROGRESS (prg_keycvtprogress), 0.5, 1);

  btn_keycvtconvert = gtk_button_new_with_label ("");
  btn_keycvtconvert_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_keycvtconvert)->child),
                                   _("_Convert"));
  gtk_widget_add_accelerator (btn_keycvtconvert, "clicked", accel_group,
                              btn_keycvtconvert_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_ref (btn_keycvtconvert);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "btn_keycvtconvert", btn_keycvtconvert,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_keycvtconvert);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), btn_keycvtconvert, 200, 96);
  gtk_widget_set_uposition (btn_keycvtconvert, 200, 96);
  gtk_widget_set_usize (btn_keycvtconvert, 80, 24);
  gtk_widget_add_accelerator (btn_keycvtconvert, "clicked", accel_group,
                              GDK_c, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  btn_keycvtcancel = gtk_button_new_with_label ("");
  btn_keycvtcancel_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btn_keycvtcancel)->child),
                                   _("C_ancel"));
  gtk_widget_add_accelerator (btn_keycvtcancel, "clicked", accel_group,
                              btn_keycvtcancel_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
  gtk_widget_ref (btn_keycvtcancel);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "btn_keycvtcancel", btn_keycvtcancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_keycvtcancel);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), btn_keycvtcancel, 112, 96);
  gtk_widget_set_uposition (btn_keycvtcancel, 112, 96);
  gtk_widget_set_usize (btn_keycvtcancel, 80, 24);
  gtk_widget_add_accelerator (btn_keycvtcancel, "clicked", accel_group,
                              GDK_a, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  cbo_keycvttypeto = gtk_combo_new ();
  gtk_widget_ref (cbo_keycvttypeto);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "cbo_keycvttypeto", cbo_keycvttypeto,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cbo_keycvttypeto);
  gtk_fixed_put (GTK_FIXED (fxd_keycvtmain), cbo_keycvttypeto, 80, 32);
  gtk_widget_set_uposition (cbo_keycvttypeto, 80, 32);
  gtk_widget_set_usize (cbo_keycvttypeto, 200, 19);
  gtk_combo_set_value_in_list (GTK_COMBO (cbo_keycvttypeto), TRUE, FALSE);
  cbo_keycvttypeto_items = g_list_append (cbo_keycvttypeto_items, (gpointer) _("BB Keys"));
  cbo_keycvttypeto_items = g_list_append (cbo_keycvttypeto_items, (gpointer) _("Fluxbox"));
  gtk_combo_set_popdown_strings (GTK_COMBO (cbo_keycvttypeto), cbo_keycvttypeto_items);
  g_list_free (cbo_keycvttypeto_items);

  txt_cbokeycvttypeto = GTK_COMBO (cbo_keycvttypeto)->entry;
  gtk_widget_ref (txt_cbokeycvttypeto);
  gtk_object_set_data_full (GTK_OBJECT (wnd_keyconvert), "txt_cbokeycvttypeto", txt_cbokeycvttypeto,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txt_cbokeycvttypeto);
  gtk_entry_set_text (GTK_ENTRY (txt_cbokeycvttypeto), _("BB Keys"));

  gtk_signal_connect (GTK_OBJECT (btn_keycvtlookupfile), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_keycvtlookupfile_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_keycvtconvert), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_keycvtconvert_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_keycvtcancel), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_keycvtcancel_clicked),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (wnd_keyconvert), accel_group);

  return wnd_keyconvert;
}

