
/*
 * keybindcb.h
 * Keybinding plugin callbacks
 *
 * Author: 	Luke Freeman
 * Copyright 2000 - 2002 Luke Freeman.
 *
 * This file is part of whiteBOX.
 *
 * whiteBOX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * whiteBOX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */

#include <gtk/gtk.h>


void
set_keys_type (int int_keystype);

void
set_keys_file (const char *str_keysfile);

void
on_btn_keyadd_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_keyremove_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_keyclearall_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeynavup_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeynavdown_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeynew_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeyload_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeysave_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeysaveas_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeyfileinfo_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_tbrkeyconvert_clicked           (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_txt_keybindkey_key_press_event      (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

gboolean
on_txt_keybindkey_focus_out_event      (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data);

gboolean
on_txt_keybindkey_key_release_event    (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);

void
on_btn_keyinfosave_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_btn_keyinfocancel_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_tgb_keybindcapture_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_lst_keysaved_select_row             (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_lst_keysaved_unselect_row           (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_txt_cbokeybindfunc_changed          (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_txt_cbokeyfiletype_changed			(GtkEditable     *editable,
                                        gpointer         user_data);

void
load_keysrc_file( GtkWidget *wgt_ref, const char *str_filename );

void
on_keybutton_pressed                  (GtkButton       *button,
                                        gpointer         user_data);
