/*
 * whiteBOX.h
 * whiteBOX global routines
 *
 * Author: 	Luke Freeman (except where specified)
 * Copyright 2001, Luke Freeman.
 *
 * This file is part of whiteBOX.
 *
 * whiteBOX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * whiteBOX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *
 *
 *
 * Bluefish HTML Editor
 *
 * Copyright (C) 1999-2001 Olivier Sessink
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <gtk/gtk.h>

#define BLACKBOX_SWITCH 1
#define FLUXBOX_SWITCH  2

#define DEBUG_FLAG      0

GList *lst_plugins;

typedef struct
{
  GdkPixmap *icon_xpm;
  GdkBitmap *icon_mask;
} wbTreeIcon;

wbTreeIcon *
get_tree_icon( int key );

int 
dir_stat( gchar *file );



/*
 * Global calls for bluefish file dialogs (all code below)
 * Download bluefish at http://bluefish.openoffice.nl
 * 
 * Copyright 1999 - 2001, Olivier Sessink. 
 * Licenced under GPL (see above notice for more details).
 */
 
gint 
free_stringlist(GList * which_list);

void 
window_destroy(GtkWidget * windowname);
